<?php //:noTabs=false:folding=explicit:tabSize=8:
/**
 *@(#)index.php - The entry point for the Weidner Foundation website.
 *
 *@author	Daniel Brandauer
 *@email	daniel@heiseysoft.com
 */

//{{{ Includes
include_once 'setup/Config.php';
include_once 'Smarty.class.php';
include_once 'Data.php';
include_once 'Util.php';
include_once 'Page.php';
include_once 'PageManager.php';
//}}}

//{{{ Presentation Manager Setup
$canvas = new Smarty();
$canvas->compile_dir = Config::getProperty('rootpath').'templates/compiled';
$canvas->config_dir = Config::getProperty('rootpath').'templates/configs';
//}}}


//{{{ Request Processing
$data = new Data();
$pm = new PageManager();
$currentId = '';

// get users locale language setting
$currentLanguage = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);

// get users requested language setting
if(isset($_GET['lang'])) {
	$currentLanguage = substr($_REQUEST['lang'],0,2);
	Config::setProperty('current language', $currentLanguage);
}

// if we don't support the requested language, use default
if(!$pm->isSupportedLanguage($currentLanguage)) {
	$currentLanguage = Config::getProperty('default language');
}

// check for request string
if(isset($_GET['request']) && $_GET['request'] != '') {
	$request = $_GET['request'];
} else {
	$request = 'home';
}

// look up requested page id
if($pm->pageIdExists($request)) {
	$currentId = $request;
} elseif($pm->pageIdExists($cid=$pm->getPageId($request))) {
	$currentId = $cid;
} else {
	$currentId = 'home';
}

// load page from database
$page =& $pm->loadPage($currentId, $currentLanguage);
$pm->loadTemplates(&$page);
$pm->loadModules(&$page);

// set up basics
$canvas->assign('title', $page->title);
$canvas->assign('categoryImage', $pm->getCategoryImage($page->category));
$canvas->assign('strings', $pm->getStrings($currentLanguage));

// setup sidebar links for category
$sideQuery = "select page_title from pages where category_name='".$page->category."' and language='$currentLanguage'";
$data->query($sideQuery);
$sideRows = array();
while($data->hasMoreRows()) {
	$sideRow = $data->fetchAssoc();
	if($sideRow != $row['page_title']) {
		$sideRows[] = $sideRow['page_title'];
	}
}
$canvas->assign('categoryPages', $sideRows);
$canvas->assign('category', ucwords($page->category));

// format content
$buffer = Util::formatProse($page->content);

// process category and page specific templates/modules
$sections = array();
foreach($page->templates as $name=>$path) {
	$sections[$name.'_path'] = $path;
}

if(is_array($page->modules)) {
	foreach($page->modules as $module) {
		include_once 'modules/'.$module->name;
		$type = $module->type;
		if($module->replaceTemplate) {
			$key = $type;
		} else {
			$key = $type.'_assist';
		}
		$sections[$key] = $type($_REQUEST);
	}
}

// add any notices to content
if($page->headnote != '') {
	$buffer = '<p><em>'.$page->headnote.'</em></p>'.$buffer;
}


// finally time to display the results
$canvas->assign('sections', $sections);
$canvas->assign('content', $buffer);
$canvas->display('page.tpl');
//}}}
?>