<?php
include_once 'Data.php';
include_once 'PageManager.php';
include_once 'Config.php';
include_once 'NewsItem.php';
include_once 'Util.php';

define('DAY', 60*60*24); // day length in seconds

function footer($args)
{
	$pm = new PageManager();
	$strings = $pm->getStrings($currentLanguage);
	$buffer = '';
	
	$items = loadNewsItems($args);
	foreach($items as $item) {
		$box = Util::formatBox(
			$item->title,
			$item->content,
			date('Y-m-d',$item->date)
			);
		$buffer .= $box;
	}
	
	if(empty($buffer)) {
		return $strings['no matching news'];
	}
	
	return $buffer;
}

function left_bottom($args)
{
	$pm = new PageManager();
	$strings = $pm->getStrings($currentLanguage);
	$buffer = '';
	
	$items = loadNewsItems($args);
	
	foreach($items as $item) {
		$box = '';
		$text = '';
		$box .= '<p>';
		$text .= '<span class="news-date">'.date('Y-m-d',$item->date).'</span><br />';
		$text .= '<span class="news-note">';
		$text .= substr($item->content, 0, 100);
		$text .= '...';
		$text .= '</span>';
		$box .= Util::makeLink(array(
			'href'=>'news/'.$item->date,
			'class'=>'news-link',
			'display'=>$text
			));
		$box .= '</p>';
		$buffer .= $box;
	}
	
	if(empty($buffer)) {
		return $strings['no matching news'];
	}
	
	return $buffer;
}

function loadNewsItems($args)
{
	global $currentLanguage;
	
	$data = new Data();
	$items = array();
	$i = 0;
	
	if(isset($args['newsitem'])) {
		$ni = $args['newsitem'];
		$query = "select * from news where news_date=$ni and language='$currentLanguage'";
	} else {
		$mindate = time() - (Config::getProperty('max news age')*DAY);
		$query = "select * from news where news_date > $mindate and language='$currentLanguage'";
	}
	
	$data->query($query);
	
	while($data->hasMoreRows()) {
		$row = $data->fetchAssoc();
		$items[$i] = new NewsItem();
		$items[$i]->date = $row['news_date'];
		$items[$i]->title = $row['news_title'];
		$items[$i]->content = $row['news_content'];
		$items[$i]->language = $row['language'];
		$i++;
	}
	
	return $items;
}
?>
