<?php
/**
 *@(#) Config.php - configuration manager
 *
 *@author	Daniel Brandauer
 *@email	daniel@heiseysoft.com
 *
 * Most all system configuration changes can be made by modifying the members
 * of the array Config::properties.
 */
class Config
{
	/**
	 * Set these values to whatever is appropriate for your system
	 */
	private static $properties = array(
		'dbname'	=>	'weidner',
		'dbuser'	=>	'weidner',
		'dbpass'	=>	'testing',
		'dbhost'	=>	'localhost',
		'localroot'	=>	'/var/www/htdocs/weidner/',
		'webroot'	=>	'/weidner/',
		'rootpath'	=>	'/var/www/htdocs/weidner/',
		'pathsep'	=>	':',
		'default language'=>	'en',
		'current language'=>	'en',
		'max news age'	=>	60 // in days
		);
	
	/**
	 * This should normally be left alone. These values will be used to 
	 * search for included files.
	 */
	private static $searchPaths = array('lib', 'lib/slib', 'setup');
	
	/**
	 * Sets up the search path, etc. Called automatically.
	 */
	public static function initialize()
	{
		global $_GET;
		
		foreach(self::$searchPaths as $path) {
			self::addPath($path);
		}
		
		if(!empty($_GET['request'])) {
			self::setProperty('current id', $_GET['request']);
		} else {
			self::setProperty('current id', 'home');
		}
	}
	
	/**
	 * Returns the value of the requested property or false if it does not
	 * exist.
	 */
	public static function getProperty($name)
	{
		if(isset(self::$properties[$name])) {
			return self::$properties[$name];
		} else {
			return false;
		}
	}
	
	/**
	 * Set global properties
	 */
	public static function setProperty($name, $value)
	{
		self::$properties[$name] = $value;
	}
	
	/**
	 * Convinience function. Makes life easier for initialize() by compiling
	 * a filesystem path from an internal path.
	 */
	public static function addPath($path)
	{
		$prepend = ini_get('include_path');
		$prepend .= self::getProperty('pathsep');
		$prepend .= self::getProperty('rootpath');
		ini_set('include_path',	$prepend.$path);
	}
}

/**
 * Auto-initialize configuration.
 */
Config::initialize();
?>
